<?php
/*
      phpHyphenator 1.6.1
      Enhanced by Erik Krause

      based on

      phpHyphenator 1.6
      Enhanced by Liedtke.IT Jens Liedtke
      PHP version of the JavaScript Hyphenator version 3.1.0 by
      Mathias Nater, <a href = "mailto:mathias@mnn.ch">mathias@mnn.ch</a>

      based on

      phpHyphenator 1.5
      Developed by yellowgreen designbüro
      PHP version of the JavaScript Hyphenator 1.0 (Beta) by Matthias Nater

      Licensed under Creative Commons Attribution-Share Alike 2.5 Switzerland
      http://creativecommons.org/licenses/by-sa/2.5/ch/deed.en

      Associated pages:
      http://yellowgreen.de/soft-hyphenation-generator/
      http://yellowgreen.de/phphyphenator/
      http://www.dokuwiki.org/plugin:hyphenation

      Special thanks to:
      Dave Gööck (webvariants.de)
      Markus Birth (birth-online.de)
      Nico Wenig (yellowgreen.de)

*/

      mb_internal_encoding("utf-8");

// FUNCTIONS

      // Convert patterns
      function convert_patterns($patterns) {
        $patterns = mb_split(' ', $patterns);
        $new_patterns = array();
        for($i = 0; $i < count($patterns); $i++) {
          $value = $patterns[$i];
          $new_patterns[preg_replace('/[0-9]/', '', $value)] = $value;
        }
        return $new_patterns;
      }

      // Split string to array
      function mb_split_chars($string) {
        $strlen = mb_strlen($string);
        while($strlen) {
          $array[] = mb_substr($string, 0, 1, 'utf-8');
          $string = mb_substr($string, 1, $strlen, 'utf-8');
          $strlen = mb_strlen($string);
        }
        return $array;
      }

      function makePHPpattern($filename){
        $lines = file($filename.'.js');
        $lines = str_replace(':','=',$lines);
        $lines = str_replace(',',';',$lines);
        $lines = str_replace('leftmin', '$leftmin',$lines);
        $lines = str_replace('rightmin',  '$rightmin',$lines);
        $lines = str_replace('shortestPattern',  '$shortestPattern',$lines);
        $lines = str_replace('longestPattern',  '$longestPattern',$lines);
        $lines = str_replace(' ',  '',$lines);
        $lines = str_replace("\t",  '',$lines);

        $pattern = '';
        $vars = '';
        foreach ($lines as $line_num => $line) {
          $num = number_format( $line);
          if($num >= 3){
            $str1 = explode('"',$line);
//            echo "<br>\n".$num."<br>\n";
            for($i=0;$i < mb_strlen($str1[1])/$num;$i++) {
              $pattern .= mb_substr($str1[1],$i*$num, $num, 'utf-8').' ';
            }
          }
          if(strpos($line,'leftmin') > 0) $vars .= $line;
          if(strpos($line,'rightmin') > 0)  $vars .= $line;
          if(strpos($line,'shortestPattern') > 0) $vars .= $line;
          if(strpos($line,'longestPattern') > 0)  $vars .= $line;
//          echo "Line #<b>{$line_num}</b> : " . htmlspecialchars($line) . "<br>\n";
        }
//        echo $pattern;
        $filename = $filename.'.php';
        if (!$handle = fopen($filename, "w")) {
             print "Unable to open file $filename";
             exit;
        }
        $pattern = '$patterns = "'.$pattern.'";';
        $pattern = $vars.$pattern;

        // Schreibe $somecontent in die geöffnete Datei.
        if (!fwrite($handle, "<?php\n".$pattern."\n?>")) {
            print "Unable to write file $filename";
            exit;
        }

        print "File $filename created";

        fclose($handle);
        return true;

      }


// GET DATA
      // Set defaults
      if(!isset($GLOBALS["language"])) $GLOBALS["language"] = "de";
      if(!isset($GLOBALS["path_to_patterns"])) $GLOBALS["path_to_patterns"] = "patterns/";
      if(!isset($GLOBALS["dictionary"])) $GLOBALS["dictionary"] = "dictionary.txt";
//      if(!isset($GLOBALS["hyphen"])) $GLOBALS["hyphen"] = "&amp;shy;";
//      if(!isset($GLOBALS["hyphen"])) $GLOBALS["hyphen"] = "&shy;";
//      if(!isset($GLOBALS["hyphen"])) $GLOBALS["hyphen"] = "-";
      if(!isset($GLOBALS["hyphen"])) $GLOBALS["hyphen"] = iconv("ISO-8859-1", "UTF-8", chr(173));
      if(!isset($GLOBALS["leftmin"])) $GLOBALS["leftmin"] = 2;
      if(!isset($GLOBALS["rightmin"])) $GLOBALS["rightmin"] = 2;
      if(!isset($GLOBALS["shortestPattern"])) $GLOBALS["shortestPattern"] = 2;
      if(!isset($GLOBALS["longestPattern"])) $GLOBALS["longestPattern"] = 10;

      if(!isset($GLOBALS["exclude_tags"])) $GLOBALS["exclude_tags"] = array("code", "pre", "script", "style");

      // Get patterns
      if(file_exists($GLOBALS["path_to_patterns"] . $GLOBALS["language"] . ".php")) {
        include($GLOBALS["path_to_patterns"] . $GLOBALS["language"] . ".php");
        $GLOBALS["patterns"] = convert_patterns($patterns);
      } else {
        if(file_exists($GLOBALS["path_to_patterns"] . $GLOBALS["language"] . ".js")) {
          if(makePHPpattern($GLOBALS["path_to_patterns"] . $GLOBALS["language"] )){
            include($GLOBALS["path_to_patterns"] . $GLOBALS["language"] . ".php");
            $GLOBALS["patterns"] = convert_patterns($patterns);
          } else    $GLOBALS["patterns"] = array();
        } else    $GLOBALS["patterns"] = array();
      }

      // Get dictionary
      file_exists($GLOBALS["dictionary"]) ? $GLOBALS["dictionary"] = file($GLOBALS["dictionary"]) : $GLOBALS["dictionary"] = array();

      foreach($GLOBALS["dictionary"] as $entry) {
        $entry = trim($entry);
        $GLOBALS['dictionary words'][str_replace('/', '', mb_strtolower($entry))] = str_replace('/', $GLOBALS['hyphen'], $entry);
      }

// HYPHENATION

      // Word hyphenation
      function word_hyphenation($word) {
        if(mb_strlen($word) < $GLOBALS["shortestPattern"]) return $word;
        if(mb_strpos($word, $GLOBALS["hyphen"]) !== false) return $word;
        if(isset($GLOBALS['dictionary words'][mb_strtolower($word)])) return $GLOBALS['dictionary words'][mb_strtolower($word)];

        $w = '_' . $word . '_';
        $wl = mb_strlen($w);
        $s = mb_split_chars($w);
        $w = mb_strtolower($w);
        $hyphenated_word = array();
        $hypos = array();
        $numb3rs = array('0' => 0, '1' => 1, '2' => 2, '3' => 3, '4' => 4, '5' => 5, '6' => 6, '7' => 7, '8' => 8, '9' => 9);

        $n = $wl - $GLOBALS["shortestPattern"];
        for ($p = 0; $p <= $n; $p++) {
          $maxwins = min(($wl - $p), $GLOBALS["longestPattern"]);
          for ($win = $GLOBALS["shortestPattern"]; $win <= $maxwins; $win++) {
            if(isset($GLOBALS["patterns"][mb_substr($w, $p, $win)])) {
              $pat = $GLOBALS["patterns"][mb_substr($w, $p, $win)];
              $pat_length = mb_strlen($pat);
    /*          if (enableReducedPatternSet) {
                lo.redPatSet[patk] = pat;
              }
    */
    //          if (typeof pat === 'string') {
                //convert from string 'a5b' to array [1,5] (pos,value)
                $t = 0;
                $val = array();
                for ($i = 0; $i < $pat_length; $i++) {
                  $c = $numb3rs[mb_substr($pat,$i,1)];
                  if (isset($c)) {
                    array_push($val,($i - $t), $c);
                    $t++;
                  }
                }
                $pat = $val;
            } else {
              continue;
            }
            for ($i = 0; $i < count($pat); $i++) {
              $c = $p - 1 + $pat[$i];
              if (!$hypos[$c] || $hypos[$c] < $pat[$i + 1]) {
                $hypos[$c] = $pat[$i + 1];
              }
              $i++;
            }
          }
        }
        $inserted = 0;
        for ($i = $GLOBALS["leftmin"]; $i <= (mb_strlen($word) - $GLOBALS["rightmin"]); $i++) {
          if (!!($hypos[$i] & 1)) {
            array_splice($s,$i + $inserted + 1, 0, $GLOBALS["hyphen"]);
            $inserted++;
          }
        }
        $hyphenatedword = implode('', array_slice($s, 1, -1));//s.slice(1, -1).join('');
    /*    if (enableCache) {
          lo.cache[word] = hyphenatedword;
        }
    */
        return $hyphenatedword;
      }

      // Text hyphenation
      function hyphenation($text) {
        global $exclude_tags; $word = ""; $tag = ""; $tag_jump = 0; $output = array();
        $word_boundaries = "<>\t\n\r\0\x0B !\"§$%&/()=?….,;:-–_„”«»‘’'/\\‹›()[]{}*+´`^|©?®™?¹²³";
        $text = $text . " ";
        $inAttr1 = false;
        $inAttr2 = false;
        for($i = 0; $i < mb_strlen($text); $i++) {
          $char = mb_substr($text, $i, 1);
          if ($tag != "") {
            if ($char == '"')
              $inAttr1 = !$inAttr1;
            if ($char == "'")
              $inAttr2 = !$inAttr2;
          }
          if(mb_strpos($word_boundaries, $char) === false && $tag == "") {
            $word .= $char;
          } else {
            if($word != "") { $output[] = word_hyphenation($word); $word = ""; }
            if($tag != "" || $char == "<") $tag .= $char;
            if($tag != "" && $char == ">" && !$inAttr1 && !$inAttr2) {
              $tag_name = (mb_strpos($tag, " ")) ? mb_substr($tag, 1, mb_strpos($tag, " ") - 1) : mb_substr($tag, 1, mb_strpos($tag, ">") - 1);
              if($tag_jump == 0 && in_array(mb_strtolower($tag_name), $exclude_tags)) {
                $tag_jump = 1;
              } else if($tag_jump == 0 || mb_strtolower(mb_substr($tag, -mb_strlen($tag_name) - 3)) == '</' . mb_strtolower($tag_name) . '>') {
                $output[] = $tag;
                $tag = '';
                $tag_jump = 0;
              }
            }
            if($tag == "" && $char != "<" && $char != ">") $output[] = $char;
          }
        }

        $text = join($output);
        return substr($text, 0, strlen($text) - 1);
      } // function hyphenation($text)
?>